/*日夜间共用js*/

/* 对于复杂的js，若日夜间代码仅有一两行日夜间的差距，可使用 ifeng.isNightMode(); 进行判断区分，将该复杂js代码放入此js，利于维护 */

var video_p = '<!-- IFENG_DOC_VIDEO -->';
var slide_p = '<!-- IFENG_DOC_SLIDE -->';
var survey_p= '<!-- IFENG_DOC_SURVEY -->';
var center_ad_p='<!-- IFENG_DOC_ADVERT -->';
var audio_p = '<!-- IFENG_DOC_AUDIO -->';

/*房产相关*/
var houselp_p='<!-- IFENG_DOC_HOUSEBUILDING -->';
var housefy_p='<!-- IFENG_DOC_HOUSERESOURCES -->';
var housexq_p='<!-- IFENG_DOC_HOUSEESTATE -->';
var housedc_p='<!-- IFENG_DOC_HOUSESURVEY -->';
var card_ad_p = '<!-- IFENG_DOC_CARD -->';
var househd_p='<!-- IFENG_DOC_HOUSEACTIVITY -->';


var EVENT_IMG_WIDTH = 0;                        //运营位活动图片宽
var EVENT_IMG_HEIGHT = 0;                       //运营位活动图片高
var EVENT_IMG_RADIO = 698 / 256;                //运营位活动图片宽高比
var IMGE_DEFAULT_HEIGHT = 90.5;
var IMAGE_PLACEHOLDER_WIDTH;
var IMAGE_PLACEHOLDER_HEIGHT;
var PLACEHOLDER_SLOPE = 174 / 294;              // 标准框比例
var VIDEO_SLOP = 9/16;                          // 视频宽高比
var BODY_AD_WIDTH = 0;                          // 正文广告宽
var BODY_AD_HEIGHT = 0;                         // 正文广告高
var BODY_AD_CENTER_RADIO = 480 / 400;           // 正文中间通发广告宽高比
var BODY_AD_RADIO = 668 / 202;                  // 正文广告宽高比


var class_iwords = 'iwords';
var FONTS={
    'small'    : 0,
    'mid'      : 1,
    'big'      : 2,
    'bigger'   : 3,
};
var jumpUrls = [];
var cropper;
var FIRSTFONT;
var image_index=0;
var SCREEN_WIDTH;
var imgQuene = [];
var srcs = [];
var topFlag = 0;

var originalHeight;


// 监听 load 事件 执行 prepare 方法初始化逻辑
window.addEventListener('load', prepare, false);

var retryCount = 0;
var RETRY_INTERVAL = 10;
var MAX_RETRY_TIMES = 100;

function prepare() {

    console.log("prepare");

    initBaseData();

    judgeAvailable();
}

/**
 * 判定当前是否可以正常使用
 *
 * 当load回调直接执行给div内部设置文字时，该div虽然高度显示无问题，但高度获取、对下方其他dom的影响都是错误的（偶现）
 * 如标题，该div的高度会错误，导致下方其他dom获取上边距全部错误，反复测试发现是时机过早，但具体原因还未查出，
 * 此处可以正常获取到document.body.clientWidth时开始执行渲染方法
 */
function judgeAvailable() {

    console.log("judgeAvailable clientWidth : " + document.body.clientWidth + ",retryCount:" + retryCount);

    if (document.body.clientWidth || retryCount > MAX_RETRY_TIMES) {
        init();
    } else {
        retryCount++;
        setTimeout(function() {
            judgeAvailable();
        }, RETRY_INTERVAL);
    }
}

function init() {

    console.log("init");

    renderDocBody();

    loadBodyAd();

    // 处理图片后 填充正文内容
    preprocessImage(formatText(datas.getText()),document.getElementById('content'), datas.getShortDocRelateTitleFontSize());

    // a标签跳转
    dealwithTextAtag(document.getElementById('content'));

    dealTelephoneComponent();

    //初始化音频
    initAudio();
    initCardAd();

    fixErrorSpace();

    dealWithSurveyContentView();

    //console.log("all text = " + document.getElementById('content').innerHTML);
}


function initBaseData() {

    athene.clear();
    athene.setUpdateTime(ifeng.getUpdateTime());

    //通过native方法获取设备宽度的DP值
    SCREEN_WIDTH = ifeng.getScreenWidth();
    console.log("SCREEN_WIDTH:" + SCREEN_WIDTH);

    var content = document.getElementById('content');
    if(content != null && content != undefined) {
        originalHeight = content.clientHeight;
    }

    IMAGE_PLACEHOLDER_WIDTH = SCREEN_WIDTH - 26;
    IMAGE_PLACEHOLDER_HEIGHT = Math.round(IMAGE_PLACEHOLDER_WIDTH * PLACEHOLDER_SLOPE);
    cropper = new ImageCropper(new StandPlaceholderCropStrategy(IMAGE_PLACEHOLDER_WIDTH));
}

function renderDocBody() {

    // 写入标题
    initNewsTitle();

    // 稿源
    initSource(datas);

    // 设置简介
    initSummary(datas.getSummary());

    // 获取自媒体信息底部的Y值
    setAuthorTitleBottomY();

    // 设置大小字体
    setFontSize(datas.getFontSize(),datas.getDocTitleFontSize(),datas.getDocContentFontSize(),datas.getSummaryFontSize());

    //在正文和作者简介中间插入banner
    initDocTopBanner(datas.getTopbannerType(),datas.getTopbannerImg());

    // 增加作者和责任编辑
    initEditorCode(datas.getAuthor(), datas.getEditorcode());

    // 初始化免责声明
    initClaimer(datas.getDisclaimer(), datas.getOriginalLink());

    // 设置图注字体
    setPicIntroFontSize(datas.getFontSize(), datas.getPicIntroFontSize());
}

function getLoadingImage() {

    var isNightMode = ifeng.isNightMode();
    if (isNightMode) {
        return '<img src="detail_image_loading_night.png" class="load-message">';
    } else {
        return '<img src="detail_image_loading.png" class="load-message">';
    }
}

function loadBodyAd() {

    //正文（中韩频道/本地）广告(内容合作)
    var isChannelHasBodyAd = ifeng.isChannelHasBodyAd();
    if (!isChannelHasBodyAd) {
        return;
    }

    var bodyAdData = datas.getRandomBodyAdvertJson();
    if (!isFieldValid(bodyAdData)) {
        return;
    }
    var adData = JSON.parse(bodyAdData);
    if (!isFieldValid(adData)) {
        return;
    }
    BODY_AD_WIDTH = SCREEN_WIDTH - 24;
    BODY_AD_HEIGHT = Math.round(BODY_AD_WIDTH / BODY_AD_RADIO);
    var bodyAdWrapper = document.getElementById('body_ad_wrapper');
    bodyAdWrapper.style.width = BODY_AD_WIDTH + 2 + 'px';
    bodyAdWrapper.style.display = 'block';
    bodyAdWrapper.onclick = function() {
        ifeng.bodyAdClick(adData.url, adData.title);
    }

    var bodyAdImage = document.getElementById('body_ad_img');
    var loadMessage = getLoadingImage();
    bodyAdImage.innerHTML = loadMessage;
    bodyAdImage.style.width = BODY_AD_WIDTH + 'px';
    bodyAdImage.style.height = BODY_AD_HEIGHT + 'px';

    var bodyAdTitle = document.getElementById('body_ad_title');
    bodyAdTitle.innerHTML = adData.title;

    ifeng.getBodyAdImage(adData.thumbnail);
}

// 获取自媒体信息底部的Y值
function setAuthorTitleBottomY(){
    var contentTop = 0;
    var detail_declare = document.getElementById('detail_declare');
    var summary_parent = document.getElementById('summary_parent');
    var content = document.getElementById('content');
    if(detail_declare && detail_declare.style.display == 'block') {
        contentTop = detail_declare.offsetTop ;
    } else if (summary_parent && summary_parent.style.display == 'inline-block'){
        contentTop = summary_parent.offsetTop ;
    }else {
        contentTop = content.offsetTop ;
    }
    ifeng.setAuthorTitleBottomYDp(contentTop);
    console.log("setAuthorTitleBottomYDp : " + contentTop);
}

//改变关注图标状态 （于Java调用）
function changeSubButtonImg(subState) {
    try{
        var newsType = ifeng.getNewsType();
        subSourceSuccessForDoc().call(null, subState);
    } catch (e) {
       console.log("error:"+e);
    }
}

function hideFeedShowSub(){
    var feedback = document.getElementById('feedback');
    feedback.style.display = 'none';
    var subButton = document.getElementById('subscribe');
    if(datas.getSubscribe()!= null && datas.getSubscribe().getForbidFollow()!='1'){
         subButton.style.display = "block";
    }
}


//显示事件运营位图片 （于Java调用）
function showBottomEventImg(imgUrl,linkType,linkUrl,isAuth,staticId) {
    EVENT_IMG_WIDTH = SCREEN_WIDTH - 24;
    EVENT_IMG_HEIGHT = Math.round(EVENT_IMG_WIDTH / EVENT_IMG_RADIO);
    var eventImgWrapper = document.getElementById('event_img_wrapper');
    eventImgWrapper.style.width = EVENT_IMG_WIDTH + 2 + 'px';
    eventImgWrapper.style.display = 'block';
    eventImgWrapper.onclick = function() {
       ifeng.onEventImgClick(linkType,linkUrl,isAuth,staticId);
    }
    var eventImage = document.getElementById('event_img');
    eventImage.style.width = EVENT_IMG_WIDTH + 'px';
    eventImage.style.height = EVENT_IMG_HEIGHT + 'px';
    eventImage.style.backgroundImage = 'url(' + imgUrl + ')';
}

function removeNotePreEmptyPBottomSpace(className) {

    if(!className || className == "" || className == 'undefined') {
        return;
    }

    try {
        //如果前一个标签是空p标签，将其下边距去掉
        var nodeList = content.getElementsByClassName(className)
        if(nodeList){
            for(j=0;j<nodeList.length;j++) {
                 var pre = nodeList[j].previousSibling;
                 if(pre && pre.tagName == 'P' && pre.innerText == ""){
                     pre.style.paddingBottom = "0px";
                     pre.style.marginBottom = "0px";
                     console.log("fixErrorSpace success");
                 } else if(className == 'survey_classes') {
                    fixSurveyErrorTopSpace(pre);
                 }
            }
        }
    } catch (e) {
        console.log("removeNotePreEmptyPBottomSpace error : " + e);
    }
}

function fixSurveyErrorTopSpace(preNode) {
    if(!preNode) {
        return;
    }

    try {
        if(preNode.nodeType == 1){
            if(!preNode.style.paddingBottom && !preNode.style.marginBottom) {
                preNode.style.paddingBottom = "0px";
                preNode.style.marginBottom = "16px";
            }
        } else {
            fixSurveyErrorTopSpace(preNode.previousSibling);
        }
    } catch (e) {
        console.log("fixErrorTopSpace error : " + e);
    }
}

//修复正文异常边距
function fixErrorSpace() {
    var content = document.getElementById("content");

    removeNotePreEmptyPBottomSpace("video");

    fixTopVideoOrImgTopSpace();

    //移除正文最后一个元素的下边距
    removeLastElementBottomSpace(content);
    //重置音频位置
    initAudio();
    console.log("fixErrorSpace");
}

/*移除该元素及其最后一个子元素底部的padding和margin*/
function removeLastElementBottomSpace(parent) {
    if(parent) {

        parent.style.paddingBottom = "0px";
        parent.style.marginBottom = "0px";

        var children = parent.children;
        if(children && children.length > 0) {
            var lastChildren = children[children.length - 1];
            removeLastElementBottomSpace(lastChildren);
        }
    }
}

//当视频或图片开头时，调整视频和图片的上边距
function fixTopVideoOrImgTopSpace() {
    var detail_declare = document.getElementById("detail_declare");
    var content = document.getElementById("content");
    var allNodeList = content.childNodes;
    if(allNodeList.length <= 1) {
        return;
    }

    //视频上面有一个空p标签占位，所以需查找两个标签
    for(i=0;i<2;i++) {
        var node = allNodeList[i];
        if(detail_declare.style.display == 'none') {
           //当不展示转载声明时，正文由视频开头，需要调整视频上边距为4px
           if(node.id == "videoContent") {
                node.style.paddingTop = "0px";
                node.style.marginTop = "4px";
                console.log("fixTopVideoOrImgTopSpace:fix top video/img space success with no declare.");
                break;
           }
        } else {
            //当展示转载声明时，正文由视频或图片开头，需要调整上边距为3px
            if(node.id == "videoContent" || node.id == "imgPlaceholder") {
                node.style.paddingTop = "0px";
                node.style.marginTop = "3px";
                console.log("fixTopVideoOrImgTopSpace:fix top video/img space success.");
                break;
            }
        }
    }
    console.log("fixTopVideoOrImgTopSpace");
}


/*房产电话咨询调用*/
function houseCallPhone(tag,telephoneStr){
    ifeng.houseTelephone(tag,"'"+telephoneStr+"'");
}
/*房卡卡片活动跳转调用*/
function toHouseCardDetail(houseLinkUrl){
    ifeng.houseLink(houseLinkUrl);
}
/*房产频道房源卡片相关*/
function buildHouseCard(content){
    var houseCardLPStr = datas.getHouseCardLPJson();
    content = handleHouseContent(content,houselp_p,houseCardLPStr);

    var houseCardFYStr = datas.getHouseCardFYJson();
    content = handleHouseContent(content,housefy_p,houseCardFYStr);

    var houseCardXQStr = datas.getHouseCardXQJson();
    content = handleHouseContent(content,housexq_p,houseCardXQStr);

    var houseCardHDStr = datas.getHouseCardHDJson();
    content = handleHouseContent(content,househd_p,houseCardHDStr);

    var houseCardDCStr = datas.getHouseCardDCJson();
    content = handleHouseContent(content,housedc_p,houseCardDCStr);
    return content;
}
function handleHouseContent(content,flag_p,sourceJson){
    if(sourceJson != null && sourceJson != "null" && sourceJson != "" && sourceJson != 'undefined'&&Object.prototype.toString.call(sourceJson) == '[object String]'){
        var houseCardList = JSON.parse(sourceJson);
        content = handleFlagWithMinLength(content,flag_p,houseCardList.length,
                function(i) {
                    return houseCardList[i].html;
                });
    }
    return content;
}

//初始化文章标题
function initNewsTitle() {
    var newsType = ifeng.getNewsType();
    document.getElementById('title').innerHTML = datas.getTitle();
    return content
}

//稿源信息
function initSource(datas){
    try{
        var wrapper = document.getElementById('time-and-source-panel');
        wrapper.onclick = function(event) {
            ifeng.gotoSubscribe("");
            event.stopPropagation();
        }
        // 头像布局
        var iconWrap = document.getElementById('cir');
        var icon = document.getElementById('source_icon');
        var iconTag = document.getElementById('source_tag');
        // 自媒体名布局
        var source = document.getElementById('source');
        var catesource = document.getElementById('catesource');
        var line = document.getElementById('verticalline');
        // 原创、时间、简介布局
        var timeLayout = document.getElementById('wrap_time_original');
        var time = document.getElementById('time');
        var src_infonormal = document.getElementById('src_infro');
        var original_content = document.getElementById('original_content');

        var catesource_str,type,cateName,imgPath,source_tag,declare,srcInfo,originalName;
        // 关注按钮
        var subButton = document.getElementById('subscribe');
        var detail_declare = document.getElementById('detail_declare');
        if(datas.getSubscribe()){
            catesource_str = datas.getSubscribe().getCateSourceForJs();
            type = datas.getSubscribe().getType();
            cateName = datas.getSubscribe().getCatename();
            imgPath = datas.getSubscribe().getLogo();
            originalName = datas.getSubscribe().getOriginalName();

            if (ifeng.isNightMode()) {
                source_tag = datas.getSubscribe().getHonorImgNight();
            } else {
                source_tag = datas.getSubscribe().getHonorImg();
            }

            declare = datas.getSubscribe().getDeclare();
            srcInfo = datas.getSubscribe().getDescription();
        }

        var newsType = ifeng.getNewsType();

        // 大风号标签
        if(catesource_str && typeof(catesource_str)!="undefined" && catesource_str!=null && catesource_str!=""){
            catesource.style.display = "block";
            line.style.display = "block";

            catesource.innerHTML = catesource_str;
        }else{
            catesource.style.display = "none";
            line.style.display = "none";
        }

        // 自媒体名
        if(typeof(cateName)!="undefined"){
           source.innerHTML = cateName;
        }else{
           source.style.display = "none";
        }

        // 时间
        if (datas.getUpdateTimeForDetail() != null && datas.getUpdateTimeForDetail() != "") {
            time.innerHTML = datas.getUpdateTimeForDetail();
        } else {
            time.style.display = "none";
        }

        //原创标签
        if (typeof(originalName)!="undefined" && originalName != null && originalName != "") {
              if (original_content != null) {
                   original_content.style.display="block";
                   original_content.innerHTML = originalName;
              }
        } else{
              if (original_content != null) {
                    original_content.style.display="none";
              }
              time.style.marginLeft = 0;
        }

        if(typeof(type)!="undefined"){
            Ground.isSubscribe(subSourceSuccessForDoc(),"");
            // 自媒体简介
            if (src_infonormal != null) {
                if (typeof(srcInfo) != "undefined" && srcInfo != null && srcInfo != "") {
                    src_infonormal.innerHTML = srcInfo;
                    if (original_content.style.display == "none" && time.style.display == "none") {
                        src_infonormal.style.marginLeft = 0;
                    }
                } else {
                    src_infonormal.style.display="none";
                }
            }
        }else{
            subButton.style.display = "none";
        }

        // 隐藏时间父布局
        var isTimeLayoutDisplayNone =  original_content.style.display == "none"
                            && time.style.display == "none"
                            && src_infonormal.style.display == "none";;
        if (isTimeLayoutDisplayNone) {
            timeLayout.style.display="none";
        }

        // 设置自媒体头像
        if(typeof(imgPath)!="undefined" && imgPath!=0){
            icon.style.display = 'block';
            Ground.loadUserHeadImageDirectly(imgPath, null,
                loadImageSuccessInterceptor(icon),
                loadSubscriptImageFailInterceptor(icon,imgPath), 'forceLoad');
        }
        // 去掉用自媒体名首字作为logo
//        else if(cateName && typeof(cateName)!="undefined"){
//            icon.style.display = 'block';
//            Ground.loadImageDirectly(cateName, null,
//                loadImageSuccessInterceptor(icon),
//                loadSubscriptImageFailInterceptor(icon,cateName), 'forceLoad');
//        }
        else{
            iconWrap.style.display = "none";
            icon.style.display = "none";
        }

        // 荣誉认证V
        if(source_tag && typeof(source_tag)!="undefined" && source_tag!=null && source_tag!=""&&source_tag != 0){
            iconTag.style.display = "block";
            Ground.loadImageDirectly(source_tag, null,
                loadImageSuccessInterceptor(iconTag),
                loadSubscriptImageFailInterceptor(iconTag,source_tag), 'forceLoad');
        }

        subButton.onclick = function(event) {
            Ground.addSubscribe(subSourceSuccessForDoc(),"");
            event.stopPropagation();
        };

        if(datas.getSubscribe()!= null && datas.getSubscribe().getForbidFollow()=='1'){
            subButton.style.display = "none";
        }

        var feedback = document.getElementById('feedback');
        if(ifeng.fromPush()){
            subButton.style.display = "none";
            feedback.innerHTML = '推送反馈';
            feedback.style.display = "block";
            feedback.onclick = function(event){
                ifeng.toastFeedBack(window.devicePixelRatio*(getTop(feedback)));
                event.stopPropagation();
            };
        }

        if(typeof(declare)!="undefined" && declare!=0) {
            detail_declare.style.display = "block";
            detail_declare.innerHTML = declare;
            document.getElementById('content').style.paddingTop = "0px";
        }
    }catch(e){
        console.log("error:"+e);
    }
}

/*正文 切换关注按钮状态*/
function subSourceSuccessForDoc() {
    return function(subState){
        var subButton = document.getElementById('subscribe');
        var isNightMode = ifeng.isNightMode();
        if(subState){
            var delSubImg = "followed_day.png";
            if(isNightMode) {
                delSubImg = "followed_night.png";
            }
            subButton.setAttribute("src", delSubImg);
        }else{
            var addSubImg = "follow_day.png";
            if(isNightMode) {
                addSubImg = "follow_night.png";
            }
            subButton.setAttribute("src", addSubImg);
        }
        console.log("subSourceSuccessForDoc");
    };
}

function getWebViewSelectedData(title){
    var value = "";
    if(window.getSelection){
        value = window.getSelection().toString();
    }else if(window.document.getSelection){
        value = window.document.getSelection().toString();
    }else if(window.document.selection){
        value = window.document.selection.createRange.text;
    }
    ifeng.getSelectedText(title,value);
}

function docSelectAll(title){
    var doc = document,
          text = doc.getElementById('ifeng-article'),
          range,
          selection;

      if (doc.body.createTextRange) {
          range = document.body.createTextRange();
          range.moveToElementText(text);
          range.select();
      } else if (window.getSelection) {
          selection = window.getSelection();
          selection.removeAllRanges();

          range = document.createRange();
          range.selectNodeContents(text);
          selection.addRange(range);
      }
      getWebViewSelectedData(title);
}

function isFieldValid(field){
    if(field != null && field != "" && field != 'undefined' && field != undefined ){
        return true
    }
    return false
}

//初始化文章简介
function initSummary(summaryStr) {
    var summaryParent = document.getElementById('summary_parent');
    var summaryContent = document.getElementById('summary');
    if (summaryStr.length > 0) {
        summaryParent.style.display = 'inline-block';
        summaryContent.innerHTML = summaryStr;
    } else {
        summaryParent.style.display = 'none';
    }

}

// 发送日志
function sendWebLog(type, msg, e) {
    var docId = datas.getDocumentId() || 'null doc id',
        eMsg = e && e.message ? e.message : 'null error msg';

    ifeng.webLog(docId + '---' + type + '---' + eMsg + '---' + msg);
}

function dealWithSurveyPlaceHolder(content){
    var surveyListStr = datas.getSurveylistJson();
    if(surveyListStr&&Object.prototype.toString.call(surveyListStr) == '[object String]'){

        var surveyList = JSON.parse(surveyListStr);
        content = handleFlagWithMinLength(content,survey_p,surveyList.length,
            function(i) {
                return '<div class="survey_classes" id="survey_content_'+i+'" style="width:100%"></div>';
            });
    }
    return content;
}

function dealWithSurveyContentView(){
    var survey_classes = document.getElementsByClassName("survey_classes");
    if(!survey_classes || survey_classes.length <= 0) {
        return;
    }

    removeNotePreEmptyPBottomSpace("survey_classes");

    renderSurveyContentView(0);
}

function renderSurveyContentView(position) {
    var id = "survey_content_"+position;
    var surveyDiv = document.getElementById(id);
    if(surveyDiv != null && surveyDiv != undefined){
       var top = window.devicePixelRatio*getTop(surveyDiv);
       console.log('dealWithSurvey, position='+position+' id=' + id+' top=' + top);

       ifeng.addSurveyViewToWebView(top,id,position);
    } else {
       //所有调查渲染完毕时，重新定位音频控件的位置
       initAudio();
       console.log('dealWithSurvey, has no survey for position='+position);
    }
}

function changeSurveyDivHeight(height,divId){
    if(!divId) {
        return;
    }

    var surveyDiv = document.getElementById(divId);
    if(surveyDiv != null && surveyDiv != undefined){
      surveyDiv.style.height = height + "px";
      console.log('changeSurveyDivHeight, height='+height+' divId=' + divId);
    }
}

/**
 * 格式化图片处理，包括：
 *     1. p标签内套多个img
 *     2. p标签内有small标签
 *     3. 一个p标签内图文混排
 *     4. 图片不在任何p标签内
 */
function formatText(text) {

    var fragment = document.createElement('div');
    fragment.innerHTML = text;

    var eles = Array.prototype.slice.call(fragment.getElementsByTagName('p'));
    for (var i = 0; i < eles.length; i++) {
         var container = eles[i];
         if(container.getElementsByTagName('small').length === 1) {
            container.className += ' img-note';
         }
    }

    var imgs = Array.prototype.slice.call(fragment.getElementsByTagName('ifengimg'));
    for (var j = 0; j < imgs.length; j++) {
         var img = imgs[j];
         if (img.parentNode.nodeName != 'P' || img.parentNode.innerText != '') {
             var newp = document.createElement('p');
             if (img.parentNode.nodeName == 'A') {
                var parent = img.parentNode;
                var temp_parent = parent.cloneNode(true);
                newp.appendChild(temp_parent);
                parent.parentNode.replaceChild(newp, parent);
             } else {
                var temp_img = img.cloneNode(false);
                newp.appendChild(temp_img);
                img.parentNode.replaceChild(newp, img);
             }
         }
    }
    //console.log("formate text 2 = " + fragment.innerHTML);
    return fragment.innerHTML;
}

/**
 * 处理正文中 文字 部分的<a>标签
 *   注意：图片外层的 <a> 在 processImage 里处理
 */
function dealwithTextAtag (container) {
    var all_a = Array.prototype.slice.call(container.getElementsByTagName('a'));
        for ( var i = 0; i < all_a.length; i++) {
             var tempA = all_a[i];
             var ifenghref = tempA.getAttribute("ifengapp-data");
             var tempHref = tempA.getAttribute("href");
             if (ifenghref != null) {
                 tempA.setAttribute("href", "javascript:void(0);");
                 tempA.onclick = function() {
                   ifeng.popupLightbox(null, -1, this.getAttribute("ifengapp-data"));
                 };
             } else if (tempHref != null) {
                 //如果这个A标签本身是调用一个js方法，则这个A标签不做处理
                 if(tempHref.startsWith("javascript")){
                    continue;
                 }

                 var type = tempA.getAttribute("type");
                 ifenghref = ifeng.getIfengHrefByHrefAndType(tempHref,type);
                 tempA.setAttribute("ifengapp-data", ifenghref);
                 tempA.setAttribute("href", "javascript:void(0);");
                 tempA.onclick = function() {
                   ifeng.popupLightbox(null, -1, this.getAttribute("ifengapp-data"));
                 };
             }
        }
}

function initCardAd(){
     var container = document.getElementById('content');
     var cardadComponent = container.getElementsByClassName('cardad');
     for(var i=0;i<cardadComponent.length;i++){
         var cardadDom = cardadComponent[i];
         ifeng.initCardAdLayout(window.devicePixelRatio*(getTop(cardadDom)),i);
         ifeng.setCardAdPosition(offsetTop(cardadDom),i);
     }
}

function initDocTopBanner(bannerType,hasBannerImg){
    var banner = document.getElementById('doc_banner');
    if(bannerType != null && bannerType != "null" && bannerType != undefined && bannerType != ""){
        banner.style.display = "block";
        //精品深度，专题，热点，话题（高度不一致）
        if(bannerType == "qualityReadingList"){
            if(hasBannerImg){
                banner.style.height = "44px";
            }else{
                banner.style.display = "none";
            }
        }else{
            if(hasBannerImg){
              banner.style.height = "104px";
            }else{
              banner.style.height = "58px";
            }
        }
        ifeng.setDocInnerTopBanner(window.devicePixelRatio*banner.clientHeight,window.devicePixelRatio*getLeft(banner), window.devicePixelRatio*getTop(banner),bannerType);
    }else{
        banner.style.display = "none";
    }
}

// 设置正文字体
function setFontSize(fs,titleFontSize,contentFontSize,summaryFontSize) {
    var tdom = document.getElementById('title');
    var declareDom = document.getElementById('detail_declare');
    var cdom = document.getElementById('content');
    var summaryParentDom = document.getElementById('summary_parent');
    var summaryDom = document.getElementById('summary');
    var unfoldDom = document.getElementById('unfold_bottom-space');
    if(fs){
    	if(FIRSTFONT){
    		var offset = FONTS[fs] - FONTS[FIRSTFONT];
       		var spans = document.getElementsByName('content_span');
   			for(var i=0; i<spans.length; i++){
    			var spanClass = spans[i].getAttribute('class');
    			for(var font in FONTS){
    				if(FONTS[font] == FONTS[spanClass]+offset){
    					spans[i].setAttribute('class', font);
    				}
    			}
    		}
		}
		FIRSTFONT = fs;
        cdom.className = 'content ' + fs;
        tdom.className = 'title '+ fs;
        declareDom.className = 'detail_declare detail_declare_color '+ fs;
        summaryParentDom.className = 'summary_parent '+ fs;
        summaryDom.className = 'summary '+ fs;
        unfoldDom.className = 'unfold_bottom-space '+ fs;

        cdom.style.fontSize  = contentFontSize +'px'
        tdom.style.fontSize  = titleFontSize +'px'
        summaryDom.style.fontSize  = summaryFontSize +'px'
//        console.log(cdom.innerHTML);
    }
    //字体大小改变时，重新定位音频控件的位置
    initAudio();
    initCardAd();
}


//初始化自媒体免责声明
function initClaimer(disclaimer, originalLink) {
    var success = false;
    if (disclaimer
        && Object.prototype.toString.call(disclaimer) === '[object String]') {
        document.getElementById("disclaimer").innerText = disclaimer;
        success = true;
    }
    if(originalLink
        && Object.prototype.toString.call(originalLink) === '[object String]') {
        success = true;
        var originBtn  = document.getElementById("originBtn");
        originBtn.innerText = "阅读原文";
        originBtn.onclick = function() {
            ifeng.jump('webfull', originalLink,"","disclaimer");
        };
    } else {
        document.getElementById("originBtn").style.display = "none";
        if(success) {document.getElementById("disclaimer").marginBottom = "0px";}
    }
    if(success) {
        if(topFlag == 0) {
            document.getElementById('ifeng-article').style.paddingBottom = "0px";
        }
        document.getElementById("disclamer_wrapper").style.display = "block";
    }
}


/**
  *  客户端正文内的热词标签点击跳转.
  *
  */
function addIWordsClickLister(container){

     var classArrs = container.getElementsByClassName(class_iwords);
     if(classArrs != null && classArrs.length > 0){

         for(var i = 0; i < classArrs.length; i ++){
             if(classArrs[i] != null && classArrs[i] != undefined){
                 classArrs[i].onclick = function(){
                      ifeng.goToSearch(this.innerText);
                 };
             }
         }
     }
}

// 设置图注字体
function setPicIntroFontSize(fs,picIntroFontSize) {
    var picIntroDom = document.getElementsByClassName("picIntro");
    if(fs){
        for (var i =0;i < picIntroDom.length;i ++) {
            picIntroDom[i].className = 'picIntro ' + fs;
        }

    }
    //字体大小改变时，重新定位音频控件的位置
    initAudio();
    initCardAd();
}

//下载图片
function loadListImages(docs, srcName) {
    var imgs = docs.getElementsByTagName('img');
    for (var i = 0; i < imgs.length; i++) {
        var imageDom = imgs[i],
            imageSrc = imageDom.getAttribute(srcName);
        if (imageSrc) {
            Ground.loadImageDirectly(imageSrc, null,
                loadImageSuccessInterceptor(imageDom, i),
                loadImageFailInterceptor(imageDom, imageDom.getAttribute(srcName)), 'false');
        }
    }
}

function offsetTop(elements) {
    var top = elements.offsetTop;
    var parent = elements.offsetParent;
    while (parent != null) {
        top += parent.offsetTop;
        parent = parent.offsetParent;
    };
    return top;
};

//作者和责任编辑
function initEditorCode(author,editorCode) {

	var editor = document.getElementById('editor');
	if((!author||author.length<1)&&(!editorCode || editorCode.length < 1)) {
		editor.style.display = 'none';
		document.getElementById('editor_div').style.display = 'none';
		return false;
	}
	var container = document.getElementById('ifeng-article');
	container.style.paddingBottom = '0px';
	var authorText = '';
	if(author&&author.length>1){
		 authorText = '作者: '+author;
	}

	var editorCodeText = '';
	if(editorCode || editorCode.length > 1){
		editorCodeText = '责任编辑: '+editorCode;
	}
	editor.style.display = 'inline';
	if(authorText && authorText.length>1){
        editor.innerHTML =authorText+'&emsp;'+editorCodeText;
    }else{
        editor.innerHTML =editorCodeText;
    }
	topFlag = 1;
	document.getElementById('insert-news').style.paddingBottom = "0px";
}

//得到图集的宽和高 如果有宽和高的话，需要重新设置min-height为返回的高
function getHeightRule() {
	var extraRule = '';
	if(arguments[0].thumbnailSize) {
        var width = arguments[0].thumbnailSize.width, height = arguments[0].thumbnailSize.height;
    	if (width && height) {
    		var minheight = 'min-height:'+IMAGE_PLACEHOLDER_HEIGHT+'px';
   			extraRule = minheight;
    	}
    }
	return extraRule;
}

function getCenterAdHeightRule(item){
    var extraRule = '';
        if(item.imageWidth && item.imageHeight) {
            var width = item.imageWidth, height = item.imageHeight;
            if (width && height) {
                var minheight = 'min-height:'+cropper.getResult(width, height).height+'px';
                extraRule = 'style="'+minheight+'"';
            }
        }
        return extraRule;
}

function getVideoRule() {
	return 'style="min-height:'+IMAGE_PLACEHOLDER_WIDTH*VIDEO_SLOP+'px"';
}

function getContentPosition(content,str) {
	var index=0,list = [];
	while((index=content.indexOf(str,index))!=-1) {
		list.push(index++);
	}
	return list;
}

function insertStr(source,str,position) {
	var str_sta = source.substring(0, position);
	var str_end = source.substring(position);
	return str_sta+str+str_end;
}

//处理正文中图片
function processImage(cropper, default_height, content, container, imgInfo) {
    var loadMessage = getLoadingImage();

    //建立一个div装载html代码
    var fragment = document.createElement('div');
    fragment.innerHTML = content;

    //获取所有图片标签(img标签在DocBody的formatText方法中替换成了ifengimg标签)
    var imgEls = Array.prototype.slice.call(fragment.getElementsByTagName('ifengimg'));

    //图片json数据是否正常，数据取自DobBody的getImgJson方法
    var isFormat = true;
    //如果传过来的json数据格式错误，使用默认底图
    if (!imgInfo || Object.prototype.toString.call(imgInfo) !== '[object String]') {
        isFormat = false;
    }
    try {

        //将Json转换为MAP
        try {
            var imgObjMap = JSON.parse(imgInfo);
        } catch (e) {
            imgObjMap = undefined;
        }

        //遍历所有图片标签
        for (var i = 0; i < imgEls.length; i++) {
            var img = imgEls[i];
            var parent = img.parentNode;
            var placeholder = document.createElement('div');

            //处理图片外层的 <a> 标签
            if (parent.nodeName == 'A') {
                var ifenghref = parent.getAttribute("ifengapp-data");
                var tempHref = parent.getAttribute("href");
                if (ifenghref != null) {
                    placeholder.setAttribute("jumpUrl", parent.getAttribute("ifengapp-data"));
                } else if (tempHref != null) {
                    var type = parent.getAttribute("type");
                    ifenghref = ifeng.getIfengHrefByHrefAndType(tempHref,type);
                    placeholder.setAttribute("jumpUrl", ifenghref);
                }
                parent.parentNode.replaceChild(img, parent);
                parent = img.parentNode;
            }

            var imgUrl = img.getAttribute('src');
            if (!imgUrl) {
                continue;
            }
//            console.log('img src = ' + imgUrl);

            var image_height = '';
            placeholder.id = 'imgPlaceholder';
            placeholder.className = 'placeholder ' + datas.getFontSize();
            placeholder.setAttribute('src', imgUrl);
            placeholder.setAttribute('index', i + image_index);
            placeholder.setAttribute('loadState', 'loading');
            placeholder.setAttribute('placeholder_tag', 'tag');
            placeholder.setAttribute('background', '#ff00ff');
            //用于点击查看图片切换
            srcs.push(img.getAttribute('src'));

            var setwidth = false;
            var image_width;
            //初始化默认底图的高（根据屏幕的宽和服务器传过来的高）
            if (isFormat && imgObjMap && imgObjMap[imgUrl]) {
                var imgObj = imgObjMap[imgUrl];
                var width = imgObj.width;
                var height = imgObj.height;
                if (width && height) {
                    result = cropper.getResult(width, height);
                    if (result.height == 0) {
                        image_height = default_height + 'px';
                    } else {
                        image_height = result.height + 'px';
                    }
                } else {
                    // 如果没有获取到高，就用默认高
                    image_height = default_height + 'px';
                }
            } else {
                var reg = new RegExp("_w(\\d+)_h(\\d+)", "g");
                var result = null,
                    next_result;

                while ((next_result = reg.exec(imgUrl)) != null) {
                    result = next_result;
                };
                var w = 0,
                    h = 0;
                if (result && result.length == 3) {
                    w = result[1];
                    h = result[2];
                }
                if (w < SCREEN_WIDTH * 0.7 && h) {
                    setwidth = true;
                    image_width = w + 'px';
                    image_height = h + 'px';
                } else {
                    if (w && h) {
                        result = cropper.getResult(w, h);
                        if (result.height == 0) {
                            image_height = default_height + 'px';
                        } else {
                            image_height = result.height + 'px';
                        }
                    } else {
                        // 如果没有获取到高，就用默认高
                        image_height = default_height + 'px';
                    }
                }
            }
            if (setwidth) {
                placeholder.style.width = image_width;
            }
            placeholder.style.height = placeholder.style.minHeight = image_height;

            placeholder.innerHTML = loadMessage;
            parent.parentNode.replaceChild(placeholder, parent);

        }
        image_index += imgEls.length;
    } catch (e) {
        sendWebLog('text img error', datas.getText());
        console.log("processImage error : "+e);
    }
    return fragment.innerHTML;
}

// 处理所有占位符（不依赖数据）
function handleFlagWithoutData(content, flag_p, getItem) {
    return handleFlagWithMinLength(content, flag_p, -1, getItem);
}

// 根据数据处理占位符，若数据与占位符数量不匹配，则按最小的数量进行加载
function handleFlagWithMinLength(content, flag_p, itemDataLength, getItem) {
    //获取所有占位符的索引列表
    var list = getContentPosition(content, flag_p);
    //占位符个数
    var length = list.length;
    //占位符文字的长度
    var flag_p_length = flag_p.length;

    if (length <= 0) {
        return content;
    }

    var i, j, temp_sum;
    var showCount = length;
    if (itemDataLength > -1) {
        showCount = Math.min(length, itemDataLength);
    }

    //移除所有占位符
    content = content.replace(new RegExp(flag_p, "gm"), "");

    //校正移除占位符后的索引位置
    for (i = 0; i < length; i++) {
        list[i] -= flag_p_length * i;
    }

    for (j = 0, temp_sum = 0; j < showCount; j++) {

        //获取getItem方法内定义的字符串
        var item_str = getItem(j);
        if (!item_str || Object.prototype.toString.call(item_str) !== '[object String]') {
            continue;
        }

        //将该字符串插入正文 每次插入需要处理之前的插入对本次插入产生的索引偏移 temp_sum
        content = insertStr(content, item_str, temp_sum + list[j]);
        temp_sum += item_str.length;
    }
    return content;
}

// 根据数据处理占位符，若数据与占位符数量不匹配，则按最大的数量进行加载
// 匹配不到占位符的数据，直接追加到末尾
function handleFlagWithMaxLength(content, flag_p, item_length, getItem) {
    var list = getContentPosition(content, flag_p);
    var length = list.length;
    var flag_p_length = flag_p.length;

    if (length > 0) {
        var i, j, temp_sum, min_length = Math.min(length, item_length);
        content = content.replace(new RegExp(flag_p, "gm"), "");
        for (i = 0; i < length; i++) {
            list[i] -= flag_p_length * i;
        }
        for (j = 0, temp_sum = 0; j < min_length; j++) {
            var item_str = getItem(j);
            if (!item_str || Object.prototype.toString.call(item_str) !== '[object String]') {
                continue;
            }
            content = insertStr(content, item_str, temp_sum + list[j]);
            temp_sum += item_str.length;
        }
        if (length < item_length) {
            for (i = item_length - 1; i >= j; i--) {
                var item_str = getItem(i);
                if (!item_str || Object.prototype.toString.call(item_str) !== '[object String]') {
                    continue;
                }
                content = item_str + content;
            }
        }
    } else {
        for (var i = item_length - 1; i > -1; i--) {
            var item_str = getItem(i);
            if (!item_str || Object.prototype.toString.call(item_str) !== '[object String]') {
                continue;
            }
            content = item_str + content;
        }
    }
    return content;
}

// 显示正文 处理图片显示底图 准备加载
function preprocessImage(content, container, shortDocRelateFontSize) {
    var loadMessage = getLoadingImage();

    var imgInfo = datas.getImgJson();
    //处理正文文本区域内的图片占位
    content = processImage(cropper, IMAGE_PLACEHOLDER_HEIGHT, content, container, imgInfo);

    // 显示中心广告
    var advertData = datas.getArticleAdDataJson();
    if (advertData && Object.prototype.toString.call(advertData) == '[object String]') {
        var adBean = JSON.parse(advertData);
        content = handleFlagWithoutData(content, center_ad_p,
            function(i) {
                if (adBean.type == 'advert') {
                    var str = '<div class = "advertdiv" id="advertdiv""></div>';
                    if (adBean.link.url) {

                        str = '<div class = "advertdiv" id = "advertdiv" style="position:relative;display:block;padding-left:60px;"' + getCenterAdHeightRule(adBean) + '><img id="advert" style="position:relative;width:100%;" class="advert" ' + ' advertsrc="' + adBean.thumbnail + '" src="' + adBean.link.url + '"/>';
                    } else {
                        return str;
                    }

                    var addTagHtml = '';
                    if(ifeng.isNightMode()) {
                        addTagHtml = '<img id="ad-close" src="ad_detail_close_night.png" ' + 'style="position:absolute;width:24px;height:24px;top:5px;right:7px;z-index:100"/>' + '<div id="ad_tag" class="adv-tag">&nbsp;广告&nbsp;</div></div>';
                    } else {
                        addTagHtml = '<img id="ad-close" src="ad_detail_clolse.png" ' + 'style="position:absolute;width:24px;height:24px;top:5px;right:7px;z-index:100"/>' + '<div id="ad_tag" class="adv-tag">&nbsp;广告&nbsp;</div></div>';
                    }
                    return str + addTagHtml;
                }
                return null;
            });
    } else {
        content = handleFlagWithoutData(content, center_ad_p,
            function(i) {
                return '<div class = "advertdiv" id="advertdiv""></div>';
            });
    }

    // 显示slide封面
    var slideData = datas.getExtSlidesJson();
    if (slideData && Object.prototype.toString.call(slideData) == '[object String]') {
        var extensionsData = JSON.parse(slideData);
        content = handleFlagWithMaxLength(content, slide_p, extensionsData.length,
            function(i) {
                if (extensionsData[i].type == 'slide') {
                    if (extensionsData[i].title) {
                        return '<p style="margin-top:26px;margin-bottom:11px; ' + getHeightRule(extensionsData[i]) + ' " class="slide" ' + ' slidesrc="' + extensionsData[i].thumbnailpic + '" src="' + extensionsData[i].url + '">' + loadMessage + '</p><div><small class="slide-small" style="line-height:23px;">' + extensionsData[i].title + '</small></div>';
                    } else {
                        return '<p style="margin-top:26px;margin-bottom:26px; ' + getHeightRule(extensionsData[i]) + '" class="slide" ' + ' slidesrc="' + extensionsData[i].thumbnailpic + '" src="' + extensionsData[i].url + '">' + loadMessage + '</p>';
                    }
                }
                return null;
            });
    }


    // 显示video封面
    var videoData = datas.getVideoJson();
    if (videoData && Object.prototype.toString.call(videoData) == '[object String]') {
        var videos = JSON.parse(videoData);
        content = handleFlagWithMaxLength(content, video_p, videos.length,
            function(i) {
                var videoItemContent = "";
                var videoTitle = videos[i].title;
                if (!videoTitle || videoTitle == "undefined") {
                    videoTitle = "";
                }
                videoItemContent += '<div id="videoContent" class="video video_bg_color" ' + getVideoRule(videos[i]) +
                    '" videoType=normal imgsrc="' + videos[i].thumbnail +
                    '" normalSrc="' + videos[i].video.Normal.src +
                    '" normalSize="' + videos[i].video.Normal.fileSize +
                    '" HDSrc="' + videos[i].video.HD.src +
                    '" HDSize="' + videos[i].video.HD.fileSize +
                    '" duration="' + videos[i].duration +
                    '" guid="' + videos[i].guid +
                    '" staticId="' + videos[i].staticId +
                    '" columnId="' + videos[i].columnId +
                    '" title="' + videoTitle +
                    '" thumbnail="' + videos[i].thumbnail +
                    '">' + loadMessage + '</div>';
                return videoItemContent;
            });
    }

    //加载音频
    var audioListStr = datas.getAudioJson();
    if (audioListStr && Object.prototype.toString.call(audioListStr) == '[object String]') {
        var audioList = JSON.parse(audioListStr);
        console.info('audioList' + audioList);
        content = handleFlagWithMinLength(content, audio_p, audioList.length,
            function(i) {
                var staticId = audioList[i].staticId
                if(staticId == "null" || staticId == 'undefined'){
                    staticId = ""
                }
                var audioItemContent = '<div class="audio" id="audio" title="' + audioList[i].title + '" desc="' + audioList[i].audioAppDesc + '" duration="' + audioList[i].duration + '" srcNor="' + audioList[i].audio.Normal.src + '" srcHD="' + audioList[i].audio.HD.src + '" guid="' + audioList[i].guid +  '" staticId="' + staticId+'" columnId="' + audioList[i].columnId + '">' +
                    '<img src="detail_audio_play.png" class="audio_img" />' +
                    '<div class="audio_info" id="audio_info">' +
                    '<div class="audio_title" id="audio_title">' + audioList[i].title + '</div>' +
                    '<div class="audio_desc" id="audio_desc">' + audioList[i].audioAppDesc + '</div>' +
                    '</div>' +
                    '<div class="audio_time" id="audio_time">' + audioList[i].duration + '</div>' +
                    '<div style="clear:both"></div>' +
                    '</div>';
                return audioItemContent;
            });
    }

    //加载卡片广告
    var cardAdListStr = datas.getCardAdJson();
    if (cardAdListStr && Object.prototype.toString.call(cardAdListStr) == '[object String]') {
        var cardAdList = JSON.parse(cardAdListStr);
        console.info('cardAdList' + cardAdList);
        content = handleFlagWithMinLength(content, card_ad_p, cardAdList.length,
            function(i) {
                var cardAdItemContent = '<div class="cardad" ></div>';
                return cardAdItemContent;
            });
    }

    // 核心提示
    var tip = datas.getIntroduction();
    if (tip && Object.prototype.toString.call(tip) == '[object String]') {
        var fragment = document.createElement('div');
        fragment.innerHTML = content;
        var childs = fragment.childNodes;
        if (childs && childs.length > 0) {
            var tipContent = "";
            if (childs[0].className == "video_parent" || childs[0].className == "slide" || childs[0].className == "placeholder") {
                tipContent = '<div class="tip-news-wrapper">' + tip + '</div>';
            } else {
                tipContent = '<div class="tip-news-wrapper-se">' + tip + '</div><div class="tip-divider-wrapper"><div class="tip-divider">&nbsp;</div></div>';
            }
            content = tipContent + content;
        }
    } else {
        document.getElementById("time-and-source-panel").style.marginBottom = "10px";
    }

    //调查
    content = dealWithSurveyPlaceHolder(content);

    /*加载房产样式，加载房产卡片内容*/
    var cardStyle = datas.getHouseCardStyle();
    if (cardStyle != null && cardStyle != "null" && cardStyle != "" && cardStyle != 'undefined' && Object.prototype.toString.call(cardStyle) == '[object String]') {
        content = insertStr(content, cardStyle, 0);
    }
    content = buildHouseCard(content);

    // 显示正文
    container.innerHTML = content;
    var eles = Array.prototype.slice.call(container.getElementsByTagName('p'));
    if (eles.length == 0) {
        container.innerHTML = '<p>' + container.innerHTML + '</p>';
    }

    // 隐藏loading,可以视情况延时调用
    if (!SCREEN_WIDTH) {
        SCREEN_WIDTH = '0';
    }
    ifeng.hideLoadingMask(SCREEN_WIDTH);
    addIWordsClickLister(container);
    // 启动加载图片
    setTimeout(loadImages, 200);
}

//获取元素的纵坐标（相对于窗口）
function getTop(e) {
        var offset = e.offsetTop;
        if (e.offsetParent != null) offset += getTop(e.offsetParent);
        return offset;
    }
    //获取元素的横坐标（相对于窗口）

function getLeft(e) {
    var offset = e.offsetLeft;
    if (e.offsetParent != null) offset += getLeft(e.offsetParent);
    return offset;
}

function matchImageUrl(imgUrl) {
    var regx = "/[\/_]w(\d{1,4})_h(\d{1,4})/i";
    var rs = regx.exec(imgUrl);
    var rs1 = regx.exec(imgUrl);
}

function formatChild(note) {
    var nodes = note.childNodes;
    var canBreak = 0;
    for (var i = nodes.length - 1; i >= 0; i--) {
        if (nodes[i].nodeType == 1 && nodes[i].nodeName == "P" && nodes[i].getAttribute("class") !== "placeholder") {
            var cNodes = nodes[i].childNodes;
            for (var j = 0; j < cNodes.length; j++) {
                if (cNodes[j].nodeType == 1) {
                    if (j == cNodes.length - 1 && (cNodes[j].nodeName == "STRONG" || cNodes[j].nodeName == "SPAN")) {
                        if (cNodes[j].childNodes.length > 0 && cNodes[j].childNodes[0].nodeName !== "SMALL") {
                            if (!canBreak) {
                                canBreak = 1;
                            }
                            break;
                        }
                    }
                } else if (cNodes[j].nodeType == 3) {
                    var inner = cNodes[j].parentNode.innerHTML;
                    if (inner) {
                        if (!canBreak) {
                            canBreak = 1;
                        }
                        break;
                    }


                }
            }
        }
    }
    return note;
}

function dealTelephoneComponent() {

    var container = document.getElementById('content');
    var telephoneComponent = container.getElementsByClassName('telephone');

    if (telephoneComponent && telephoneComponent.length > 0) {
        var telphoneLabel;
        for (var i = 0; i < telephoneComponent.length; i++) {
            telphoneLabel = telephoneComponent[i];
            telphoneLabel.onclick = function() {
                //sendWebLog('text telephone', "you click : "+this.innerText);
                ifeng.makeTelephone(this.innerText);
            };
        }
    }
}

// 滚动加载图片
function loadImages() {
    if (document.getElementById('advertdiv')) {
        ifeng.setCenterAdPosition(offsetTop(document.getElementById('advertdiv')));
    }
    var container = document.getElementById('content'),
        placeholders = Array.prototype.slice.call(container.getElementsByClassName('placeholder')),
        src, docId = datas.getDocumentId(),
        loadMessage = getLoadingImage();

    var videoComponent = container.getElementsByClassName('video');

    var slideComponent = container.getElementsByClassName('slide');

    var advertComponent = container.getElementsByClassName('advert');

    var videoJumpComponent = container.getElementsByClassName('video-bottom');

    var tipContainer = document.getElementById('news-content');
    var tipPlaceHolders = Array.prototype.slice.call(tipContainer.getElementsByClassName('placeholder'))

    if (placeholders && placeholders.length >= 0 && tipPlaceHolders && tipPlaceHolders.length > 0) {
        placeholders = placeholders.concat(tipPlaceHolders);
    }

    //加载视频图片
    for (var i = 0; i < videoComponent.length; i++) {
        var videoDom = videoComponent[i];
        var jumpDom = videoJumpComponent[i];
        imgQuene.push({
            ot: videoDom.offsetTop,
            dom: videoDom,
            src: videoDom.getAttribute('imgsrc')
        })
        videoDom.onclick = function() {
            loadState = this.getAttribute('loadState');
            if (loadState == 'loadFail') {
                //如果没有网络连接，直接提示无网络
                if (ifeng.checkNetWorkState() == 0) {
                    return;
                }
                src = this.getAttribute('imgsrc');
                handle_video_message(this, 1);
                this.setAttribute('loadState', 'loading');
                Ground.loadImageDirectly(src, docId,
                    loadImageSuccessInterceptor(this),
                    loadImageFailInterceptor(this, src), 'forceLoad');
            }
            ifeng.playVideo(window.devicePixelRatio * this.clientHeight, window.devicePixelRatio * getLeft(this), window.devicePixelRatio * getTop(this), this.getAttribute('normalSrc'), this.getAttribute('HDSrc'), this.getAttribute('videoType'), this.getAttribute('duration'), this.getAttribute('guid'), this.getAttribute('staticId'), this.getAttribute('columnId'), this.getAttribute('title'), this.getAttribute('thumbnail'));
        };

        /***
         * 打开凤凰视频app or 下载凤凰视频app。
         */
        if (jumpDom) {
            jumpDom.onclick = function() {
                var guid = this.getAttribute('guid');
                ifeng.jumpIfengVideoApp(guid);
            };
        }
    }

    //加载中心广告图片
    for (var i = 0; i < advertComponent.length; i++) {
        var advertDom = advertComponent[i];
        imgQuene.push({
            ot: advertDom.offsetTop,
            dom: advertDom,
            src: advertDom.getAttribute('advertsrc')
        })
        document.getElementById('advertdiv').style.width = ifeng.getScreenWidth() - 60 + 'px';
        document.getElementById('advertdiv').style.height = Math.round((ifeng.getScreenWidth() - 120) / BODY_AD_CENTER_RADIO) + 'px';
        advertDom.onclick = function() {
            index = parseInt(this.getAttribute('index'));
            src = this.getAttribute('advertsrc');
            isLoaded = (this.className).indexOf('loaded') > -1;
            loadState = this.getAttribute('loadState');
            if (isLoaded) {
                ifeng.centerAdClick();
            } else {
                if (loadState == 'loadFail') {
                    //如果没有网络连接，直接提示无网络
                    if (ifeng.checkNetWorkState() == 0) {
                        return;
                    }
                    this.innerHTML = loadMessage;
                    this.setAttribute('loadState', 'loading');
                    Ground.loadImageDirectly(src, docId,
                        loadImageSuccessInterceptor(this),
                        loadImageFailInterceptor(this, src), 'forceLoad');
                }
            }
        };
    }
    //加载图集图片
    for (var i = 0; i < slideComponent.length; i++) {
        var slideDom = slideComponent[i];
        imgQuene.push({
            ot: slideDom.offsetTop,
            dom: slideDom,
            src: slideDom.getAttribute('slidesrc')
        })

        slideDom.onclick = function() {
            index = parseInt(this.getAttribute('index'));
            src = this.getAttribute('slidesrc');
            isLoaded = (this.className).indexOf('loaded') > -1;
            loadState = this.getAttribute('loadState');
            if (isLoaded) {
                ifeng.goToSlide(this.getAttribute('src'));
            } else {
                if (loadState == 'loadFail') {
                    //如果没有网络连接，直接提示无网络
                    if (ifeng.checkNetWorkState() == 0) {
                        return;
                    }
                    this.innerHTML = loadMessage;
                    this.setAttribute('loadState', 'loading');
                    Ground.loadImageDirectly(src, docId,
                        loadImageSuccessInterceptor(this),
                        loadImageFailInterceptor(this, src), 'forceLoad');
                }
            }
        };
    }

    for (var i = 0; i < placeholders.length; i++) {
        var imgDom = placeholders[i];
        src = imgDom.getAttribute('src');
        //   console.log('img '+i+' offsetTop=' + imgDom.offsetTop);
        imgQuene.push({
            ot: imgDom.offsetTop,
            dom: imgDom,
            src: src
        })
        // 点击判断加载状态 执行重新加载 或 显示幻灯
        imgDom.onclick = function(i) {
            var index, src, isLoaded, loadState;
            index = parseInt(this.getAttribute('index'));
            src = this.getAttribute('src');
            isLoaded = (this.className).indexOf('loaded') > -1;
            loadState = this.getAttribute('loadState');
            if (isLoaded) {
                ifeng.popupLightbox(srcs, index, this.getAttribute('jumpUrl'));
            } else {
                if (loadState == 'loadFail') {
                    //如果没有网络连接，直接提示无网络
                    if (ifeng.checkNetWorkState() == 0) {
                        return;
                    }
                    this.innerHTML = loadMessage;
                    this.setAttribute('loadState', 'loading');
                    Ground.loadImageDirectly(src, docId,
                        loadImageSuccessInterceptor(this),
                        loadImageFailInterceptor(this, src), 'forceLoad');
                }
            }
        };
    }

    // 开始加载所有正文图片
    for (var j = 0, len = imgQuene.length, load; j < len; j++) {
        var d = imgQuene[j];
        if (d.dom.getAttribute('imgsrc')) {
            handle_video_message(d.dom, 1);
        }
        load = true;
        Ground.loadImage(d.src, docId,
            loadImageSuccessInterceptor(d.dom, j),
            loadImageFailInterceptor(d.dom, d.src), 'false', load);

    }
    ifeng.startDownload();
}

/*
 处理视频图片加载状态
 state
 0 未加载
 1 正在加载
 2 加载失败
 3 加载成功显示btn
 4 加载成功不显示btn
 */
function handle_video_message(item, state) {
    try {
        var loadMessage = '';
        switch(state) {
            case 0:
            case 2:
                item.innerHTML = getLoadingImage();
                break;
            case 1:
                loadMessage = getLoadingImage();
                item.innerHTML = loadMessage+'<div class="video_bottom_content_hide"><div class="video_right_button"><img src="video_button.png"/></div></div>';
                break;
            case 3:
                    item.innerHTML ='<div class="video_bottom_content_show"><div class="video_right_button"><img src="video_button.png"/></div></div>';
                break;
            case 4:
                item.innerHTML = '';
                break;
        }
    }catch(e){console.log("error:"+e);};
}

function setImageHeight(placeholder) {
    var height = placeholder.getAttribute("image_height");
    if(height && Object.prototype.toString.call(height) == '[object String]') {
        placeholder.style.height = placeholder.style.minHeight = placeholder.style.maxHeight= height;
        ifeng.resize(document.body.getBoundingClientRect().height);
    }
}

// 图片加载的成功回调
function loadImageSuccessInterceptor(placeholder, imgPosition) {
    return function(src) {
        if (placeholder.nodeName != 'IMG') {
            if (placeholder.getAttribute('imgsrc')) {
                handle_video_message(placeholder, 3);
            } else {
                placeholder.innerHTML = '';
            }
        }
        if (src == "none") {
            placeholder.setAttribute('loadState', 'loadFail');
            return;
        }

        //加载成功了
        var className = placeholder.className;
        //		imgQuene[imgPosition] = false;
        if (className.indexOf('loaded') > -1) {
            return;
        }
        if (placeholder.getAttribute('commentImageSrc') || placeholder.getAttribute('likeSrc') || placeholder.getAttribute('recommendSrc') || placeholder.getAttribute('readImgSrc')) {
            placeholder.src = src;
        } else if (placeholder.getAttribute('imgsrc')) {
            setImageHeight(placeholder);
            placeholder.style.backgroundSize = '100%,100%';
            placeholder.style.backgroundImage = 'url(' + src + ')';
        } else if (placeholder.getAttribute('advertsrc')) {
            document.getElementById('advertdiv').style.width = ifeng.getScreenWidth() - 60 + 'px';
            document.getElementById('advertdiv').style.height = Math.round((ifeng.getScreenWidth() - 120) / BODY_AD_CENTER_RADIO) + 'px';
            placeholder.src = src;

            var adCloseEl = document.getElementById('ad-close');
            adCloseEl.onclick = function(event) {
                ifeng.setCenterAdHint();
                document.getElementById('advertdiv').style.display = 'none';
                event.stopPropagation();
            };
            if (datas.getDocAdClose() == '1') {
                adCloseEl.style.display = 'visibility';
            } else {
                adCloseEl.style.display = 'none';
            }
            ifeng.setCenterAdPosition(offsetTop(document.getElementById('advertdiv')));
            ifeng.setCenterAdHeight(Math.round((ifeng.getScreenWidth() - 120) / BODY_AD_CENTER_RADIO));
        } else if (placeholder.getAttribute('slidesrc')) {
            setImageHeight(placeholder);
            placeholder.style.backgroundImage = 'url(slide_text.png),url(' + src + ')';
            placeholder.style.backgroundSize = '40px 22px,cover';
        } else if (placeholder.getAttribute('placeholder_tag')) {
            placeholder.innerHTML = getLoadedImage();
            setImageHeight(placeholder);
            placeholder.style.backgroundSize = '100%,100%';
            placeholder.style.backgroundColor = 'transparent';
            placeholder.style.backgroundPosition = 'center top';
            showLoadedImage(placeholder, src);
        } else {
            setImageHeight(placeholder);
            placeholder.style.backgroundSize = '100%,100%';
            placeholder.style.backgroundImage = 'url(' + src + ')';
            placeholder.style.backgroundPosition = 'center top';
            placeholder.style.backgroundColor = 'transparent';
        }
        placeholder.className = className + ' loaded';

    };
}

function getLoadedImage() {
    var loaded = '<img id="loadedImg" style="width: 100%; height: auto; border-radius:4px;"/>'
    return loaded;
}

function showLoadedImage(placeholder, imgUrl) {
    if (placeholder.getAttribute('placeholder_tag')) {
        var loadedImg = placeholder.firstChild;
        loadedImg.setAttribute('src', imgUrl);
    }
}

function loadImageFailInterceptor(placeholder, src) {
    return function() {
        if (placeholder.nodeName != 'IMG') {
            if (placeholder.getAttribute('imgsrc')) {
                handle_video_message(placeholder, 2);
            } else {
                placeholder.innerHTML = getLoadingImage();
            }
        }
        if (placeholder.getAttribute('recommendSrc') || placeholder.getAttribute('readImgSrc')) {
            placeholder.src = 'list_default.jpg';
        } else if (placeholder.getAttribute('likeSrc')) {
            placeholder.src = 'album_default.JPG';
        }
        placeholder.setAttribute('loadState', 'loadFail');
        sendWebLog('loadImageFailInterceptor load img fail', src);
    };
}

// 订阅模块加载失败回调
function loadSubscriptImageFailInterceptor(placeholder, src) {
    return function() {
        placeholder.style.backgroundPosition = 'center top';
        placeholder.setAttribute('loadState', 'loadFail');
        sendWebLog('loadSubscriptImageFailInterceptor load img fail', src);
    };
}

// 与native交互实现
(function() {
    var toString = function(v) {
            return Object.prototype.toString.call(v);
        },
        isFunction = function(v) {
            return toString(v) === '[object Function]';
        },
        athene = {},
        CALLBACK_PREFIX = 'callback__',
        doc_update_time_prefix = 'none__',
        callbacks = {},
        callbackCount = 0,
        CallbackStatus = {
            OK: 1
        };
    athene.exec = function(success, fail, service, action, params) {
        //增加正文更新时间，图片加载为异步，若正文有更新，则抛弃任务
        var callbackId = CALLBACK_PREFIX + doc_update_time_prefix + callbackCount++;
        callbacks[callbackId] = {
            success : success,
            fail : fail
        };
        params = Array.prototype.concat.call([], callbackId, params || []);
        action.apply(service, params);
    };
    athene.complete = function() {
        if (arguments.length < 2) {
            throw new Error('Missing essential arguments');
        }
        var callbackId = arguments[0],
            status = arguments[1],
            callback = callbacks[callbackId],
            params = Array.prototype.slice
            .call(arguments, 2),
            success, fail;
        delete callbacks[callbackId];
        if (!callback) {
            return;
        }
        success = callback.success;
        fail = callback.fail;
        if (status == CallbackStatus.OK && isFunction(success)) {
            success.apply(null, params);
//            console.log('params= '+ params[0]);
        } else if (isFunction(fail)) {
            fail.apply(null, params);
        }
    };
    athene.clear = function() {
            callbacks = {};
            callbackCount = 0;
        };
    athene.setUpdateTime = function(updateTime) {

        if(updateTime != null && updateTime != "null" && updateTime != ""
            && updateTime != 'undefined'&& Object.prototype.toString.call(updateTime) == '[object String]'){
                doc_update_time_prefix = updateTime + "__";
        }
    };
    window['athene'] = athene;
})();

// ground 接口
(function() {
    var Ground = {
        loadImage: function(src, documentId, success, fail, forceLoad, load) {
            athene.exec(success, fail, ifeng, ifeng.loadImage, [src,
                documentId, forceLoad, load
            ]);
        },
        loadImageDirectly: function(src, documentId, success, fail, forceLoad) {
            athene.exec(success, fail, ifeng, ifeng.loadImageDirectly, [src, documentId,
                forceLoad
            ]);
        },
        loadUserHeadImageDirectly: function(src, documentId, success, fail, forceLoad) {
            athene.exec(success, fail, ifeng, ifeng.loadUserHeadImageDirectly, [src, documentId,
                forceLoad
            ]);
        },
        addSubscribe: function(success, fail) {
            athene.exec(success, fail, ifeng, ifeng.addSubscribe);
        },
        isSubscribe: function(success, fail) {
            athene.exec(success, fail, ifeng, ifeng.isSubscribe);
        }
    };

    window['Ground'] = Ground;
})();

function initAudio() {
    var container = document.getElementById('content');
    var audioComponent = container.getElementsByClassName('audio');
    for (var i = 0; i < audioComponent.length; i++) {
        var audioDom = audioComponent[i];
        //audioDom.clientHeight，getleft(audioDom)获取的值在低版本（4.4以下）中是错误的
        //为了兼容低版本手机控件高度写死为60，左边距15；
        ifeng.initAudioLayout(window.devicePixelRatio * 70, window.devicePixelRatio, window.devicePixelRatio * (getTop(audioDom) + 10), audioDom.getAttribute('title'), audioDom.getAttribute('desc'), audioDom.getAttribute('duration'), audioDom.getAttribute('srcNor'), audioDom.getAttribute('srcHD'), audioDom.getAttribute('guid'),datas.getDocumentId(),audioDom.getAttribute('staticId'));
    }
}

/*
 *  正文广告的显示控制
 */
function setBodyAd(src) {
    var bodyAdImage = document.getElementById('body_ad_img');
    bodyAdImage.innerHTML = '';
    if (src == 'none') {
        bodyAdImage.style.backgroundImage = 'url(slide_text.png),url(logo_no_load.png)';
    } else {
        bodyAdImage.style.backgroundImage = 'url(' + src + ')';
    }
}

//检测正文content的高度，当有变化时进行通知
//Js的MutationObserver不兼容大于37版本的Android WebView，某些低版本手机无法支持，这里依赖原生轮询调用
//https://developer.mozilla.org/zh-CN/docs/Web/API/MutationObserver
function notifyIfContentHasHeight() {

    if(originalHeight == null || originalHeight == undefined) {
        console.log("originalHeight is undefined now, please wait.")
        return;
    }

    var content = document.getElementById('content');
    if (content != null && content != undefined) {
       var currentHeight = content.clientHeight;
        if (currentHeight > originalHeight) {
            ifeng.notifyOnContentHasHeight(currentHeight);
            console.log("notifyIfContentHasHeight " + currentHeight)
        }
    }
}